#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e6 + 5;
const long long MOD = 998244353;

vector<int> g[MAXN], sz(MAXN);

void dfs(int v, int p) {
    sz[v] = 1;
    for (auto u : g[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v);
        sz[v] += sz[u];
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    int k;
    cin >> k;
    cin >> k;
    vector<int> p(n + 1);
    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    dfs(1, 0);
    long long ans = 1;
    for (auto u : g[k]) {
        ans = ans * (sz[u] + 1) % MOD;
    }
    ans = ans * 2 % MOD;
    cout << (ans - sz[k] + MOD) % MOD;
}
